#include <stdio.h>
#ifndef _err_h_
#include <err.h>
#endif

char err_NAME[]    = "error messaging";
char err_VERSION[] = "2.0.0";
char err_DATEVER[] = "20/08/2001";
char *err_TEXT[] = {
    "       ",
	"MESSAGE",
	"ERROR  ",
	"WARNING",
	"INFO   ",
	"DEBUG  ",
	"TRACE  ",
};

#if defined(ERR_LEVEL)
int  err_LEVEL = ERR_LEVEL
#else
#if defined(__DEBUG__)
int  err_LEVEL = err_DEBUG;
#else 
#if defined(__TRACE__)
int err_LEVEL  = err_TRACE;
#else
int err_LEVEL  = err_WARNING;
#endif
#endif
#endif
 
FILE *err_FILE = NULL;

#if defined(__GNUC__) || defined(_SUN_) 
void 
err_write(int level, char *file, int line, char *func, char *fmt, ...) {
    va_list args;
    char buf[1024], buf2[1024];
    va_start(args, fmt);
	if (!err_FILE) err_init(NULL, -1);
	if (level > err_LEVEL) return;
	if (func) {
		sprintf(buf2, "%s in %s (%s:%d): %s", err_TEXT[level], func, file, line, fmt);
	} else {
		sprintf(buf2, "%s at %s:%d: %s", err_TEXT[level], file, line, fmt);
	}
    vsprintf(buf, buf2, args);
    fprintf(err_FILE, "%s\n", buf);
    va_end(args);
}
#else 
void err_message(char *fmt, ...) {
	va_list args; va_start(args,);
	err_write(err_MESSAGE, "NOFILE", -1, NULL, fmt , args);
	va_end(args);
}
void err_error(char *fmt, ...) {
	va_list args; va_start(args,);
	err_write(err_ERROR, "NOFILE", -1, NULL, fmt , args);
	va_end(args);
}
void err_warning(char *fmt, ...) {
	va_list args; va_start(args,);
	err_write(err_WARNING, "NOFILE", -1, NULL, fmt , args);
	va_end(args);
}
void err_info(char *fmt, ...) {
	va_list args; va_start(args,);
	err_write(err_INFO, "NOFILE", -1, NULL, fmt , args);
	va_end(args);
}
void err_debug(char *fmt, ...) {
	va_list args; va_start(args,);
	err_write(err_DEBUG, "NOFILE", -1, NULL, fmt , args);
	va_end(args);
}
void err_trace(char *fmt, ...) {
	va_list args; va_start(args,);
	err_write(err_TRACE, "NOFILE", -1, NULL, fmt , args);
	va_end(args);
}
void 
err_write(int level, char *file, int line, char *func, char *fmt, va_list args) {
    char buf[1024], buf2[1024];
	if (!err_FILE) err_init(NULL, -1);
	if (level > err_LEVEL) return;
	if (func) {
		sprintf(buf2, "%s in %s (%s:%d): %s", err_TEXT[level], func, file, line, fmt);
	} else {
		sprintf(buf2, "%s at %s:%d: %s", err_TEXT[level], file, line, fmt);
	}
    vsprintf(buf, buf2, args);
    fprintf(err_FILE, "%s\n", buf);
}
#endif 

void err_init(char *filename, int level) {
    if (filename) err_FILE = fopen(filename, "w");
	if (!err_FILE) err_FILE = stderr;
	err_level_set(level);
	err_message("%s version %s initialisation (level = %s)", err_NAME, err_VERSION, err_TEXT[err_LEVEL]);
}

int err_level_set(int level) {
    if (level >= err_ERROR) err_LEVEL = level;
	return err_LEVEL;
}


