
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include <err.h>
#include <shmem.h>

#define KEY 666
#define SIZE 1024

void
part1() {
	char *s;

	printf("part1: start %d\n", getpid());
	printf("part1: create shm\n");	
	if (!(s = shmem_new(KEY, SIZE, 0))) exit(1);
	printf("part1: s        = %x\n", s);
	printf("part1: id       = %d\n", shmem_id(s));
	printf("part1: refcount = %d\n", shmem_refcount(s));
	printf("part1: key      = %d\n", shmem_key(s));
	printf("part1: size     = %d\n", shmem_size(s));
	printf("part1: real     = %d\n", shmem_real(s));
	printf("part1: set double\n");
	*(double *) s = 1234.56789;
	printf("part1: double   = %f\n", *(double *) s);
	printf("part1: sleep(3)\n");
	sleep(3);
	printf("part1: destroy shm\n");
	shmem_destroy(s);
	printf("part1: end\n");
}

void 
part2() {
	char *s;

	printf("part2: start\n");
	printf("part2: sleep(2)\n");
	sleep(2);
	printf("part2: attach shm\n");	
	if (!(s = shmem_attach(KEY))) exit(2);
	printf("part2: s        = %x\n", s);
	printf("part2: id       = %d\n", shmem_id(s));
	printf("part2: refcount = %d\n", shmem_refcount(s));
	printf("part2: key      = %d\n", shmem_key(s));
	printf("part2: size     = %d\n", shmem_size(s));
	printf("part2: real     = %d\n", shmem_real(s));
	printf("part2: double   = %f\n", *(double *) s);
	printf("part2: detach shm\n");
	shmem_detach(s);
	printf("part2: end\n");
}

int
main(void) {
	int p;

	p = fork(); 

    if (p == 0) { 
        part2();
		return 0;
    } else if (p < 0) {
        err_error("fork failed (p = %d)\n", p);
        exit(22);
    }
	part1();
	return 0;
}

