

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <strings.h>
#include <string.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>

#include <err.h>
#include <srv.h>

#define TO 10

void 
dispatch(psrv_t s, int fd, char *m) {
	char b[4096];
	
	if (!strncmp(m, "GET", 3)) {
		sprintf(b, "<html>\n<head>\n<title>Page vide</title>\n</head>\n<body></body>\n</html>\n");
		srv_send(fd, b, strlen(b) + 1);
	} else if (!strncmp(m, "HLP", 3)) {
		sprintf(b, "GET => chargement d'une page\nHLP => this message\nBYE => fermer la connexion");
		srv_send(fd, b, strlen(b) + 1);
	} else if (!strncmp(m, "BYE", 3)) {
		sprintf(b, "BYE-ACK\n");
		srv_send(fd, b, strlen(b) + 1);
		srv_client_disconnect(s, fd);
		exit(0);
	} else {
		sprintf(b, "Bad request");
		srv_send(fd, b, strlen(b) + 1);
	}
}

void 
server(psrv_t s, int fd) {
	char b[101];
	
	printf("created srv %d\n", fd);

	sprintf(b, "connected");
	srv_send(fd, b, strlen(b) + 1);
	
	while (1) {
		if (srv_recv_to(fd, b, 100, TO, 0)) {
			dispatch(s, fd, b);
		} else {
			printf("srv #%d : no client request after %d sec\n", fd, TO);
		}
	}
}

int
main(void) {
	psrv_t s;
	pid_t p;

	/* signal(SIGCHLD, sigchild_catch); */
	signal(SIGCHLD, SIG_IGN);
	
	if (!(s = srv_new(3303, 20))) return 1;

	
	while (1) {
		int fd;

		if ((fd = srv_client_connect(s)) > 0) {
			p = fork();
			if (p == 0) {
				server(s, fd);
			} else if (p < 0) {
				err_error("fork failed (p = %d)\n", p);
			} else {
				srv_client_disconnect(s, fd);
			}
		}
	}
	return 0;
}
